import { Meta } from "@storybook/blocks";
import rijkskleuren from "../../../.storybook/static/rijkskleuren.json";

export const arrowStyle = {
  marginLeft: "4px",
  display: "inline-block",
  shapeRendering: "inherit",
  verticalAlign: "middle",
  fill: "currentColor",
  "path fill": "currentColor",
};
export const RightArrow = () => (
  <svg viewBox="0 0 14 14" width="8px" height="14px" style={arrowStyle}>
    <path d="m11.1 7.35-5.5 5.5a.5.5 0 0 1-.7-.7L10.04 7 4.9 1.85a.5.5 0 1 1 .7-.7l5.5 5.5c.2.2.2.5 0 .7Z" />
  </svg>
);

export function dotnotation(obj, dst = {}, prefix = "") {
  Object.entries(obj).forEach(([key, val]) => {
    if (val && typeof val == "object") dotnotation(val, dst, prefix + key + "-");
    else dst[prefix + key] = val;
  });
  return dst;
}

export const TailwindColors = () => {
  const colors = Object.entries(dotnotation(rijkskleuren)).map(([key, value]) => {
    return (
      <div
        key={key.replace("-DEFAULT", "")}
        className={`aspect-square p-2`}
        style={{ '{{' }} backgroundColor: value {{ '}}'}}
      >
        {key.replace("-DEFAULT", "")}
      </div>
    );
  });
  return <div className="grid grid-cols-2 gap-4 sm:grid-cols-3 md:grid-cols-5">{colors}</div>;
};

<Meta title="Resources/Rijkshuisstijl" />

<div className="sb-container">
  <div className='sb-section-title'>
    # Rijkshuisstijl
    We use the [Rijkshuisstijl](https://www.rijkshuisstijl.nl/) as a base for our design system.
    This is a collection of colors, fonts, icons and other design elements that are used by the Dutch government.

    ## Iconography
    The icons and logos that are used are those from Rijkswaterstaat.
    These logos fall under a proprietary license and are not included in the repository.
    If you wish to use other icons or logos you can change them at the following locations:
    - `static/favicon.ico`
    - `static/img/logo.png`

    ## Fonts
    The fonts that are used are the `ROSansWeb` and `ROSerifWeb` fonts.
    These fonts have been downloaded from the [typography](https://www.rijkshuisstijl.nl/publiek/modules/product/DigitalStyleGuide/default/index.aspx?ItemId=6745)
    section of the Rijkshuisstijl website. The fonts should be included in the `public/fonts` folder.

    <blockquote className="!border-l-4 !border-rood">
      <strong class="!font-bold !text-rood">Note:</strong> The fonts have a proprietary license and are not included in the repository.
    </blockquote>

    ## Colors
    The colors can be called by their name as a `tailwindcss` class.
    We specifically override the default colors of `tailwindcss` with the colors of the Rijkshuisstijl to
    ensure consistency with the rest of the government.
    ```html
    <div class="bg-hemelblauw">Blue background</div>
    <div class="text-hemelblauw">Blue text</div>
    {/* ... */}
    ```

  </div>
  {TailwindColors()}
</div>
